#!/usr/bin/env python
# -*- coding: utf-8 -*-

import sys
import os
import time
from SOAPpy import WSDL
import libxml2
import urllib2
import socket
import cookielib

socket.setdefaulttimeout(20)
cj = cookielib.LWPCookieJar()
opener = urllib2.build_opener(urllib2.HTTPCookieProcessor(cj))
urllib2.install_opener(opener)

def getUrlsIdsFromOriIndexing():

    urls_ids = []

    WSDLFILE = 'http://localhost:6380/ori-oai-indexing/xfire/IndexingService?wsdl'
    oriindexing = WSDL.Proxy(WSDLFILE)

    # oai_dc
    request = 'md-ori-oai-namespace:("http://www.openarchives.org/OAI/2.0/oai_dc/")'
    print request
    results = oriindexing.searchXMLDocs(request, 1, 10000)['results']['SearchResult']
    for result in results:
        if result['id'] != None and result['noticeContent']!= None:
            id = result['id']
            url_img = 'http://localhost/ori-imgs/thumb150-' + id +'.png '
            try:
                url_open = urllib2.urlopen(url_img)
            except urllib2.URLError, e:
                if(e.code==404):
                    #urls_ids.append(id)
                    xml = result['noticeContent'].encode('utf-8')
                    doc = libxml2.parseDoc(xml)
                    ctxt = doc.xpathNewContext()
                    res = []
                    ctxt.xpathRegisterNs('dc', 'http://purl.org/dc/elements/1.1/')
                    res = ctxt.xpathEval("//dc:identifier")
                    for r in res:
                        if r.get_content()[:4] == 'http':
                            res_url = r.get_content()
                            urls_ids.append(res_url)

    print len(urls_ids)
    for url in urls_ids:
        print url
    
getUrlsIdsFromOriIndexing()




