#!/usr/bin/env python
# -*- coding: utf-8 -*-

import os
import time
from SOAPpy import WSDL
import libxml2
import urllib


def closeFirefox():
    os.system('killall -3 firefox')
    os.system('killall -4 firefox-bin')
    os.system('killall -9 firefox-bin')

def closeXvfb():
    os.system('killall -9 Xvfb')


def initXvfb():
    psXvfb = os.popen('ps -edf | grep Xvfb').readlines()
    if len(psXvfb) < 3:
        os.system('Xvfb :1 -screen 0 1280x960x24&')
        #os.system('Xvfb :1 -screen 0 1024x768x24&')
        time.sleep(3)

def launchFirefox(url):
    psFirefox = os.popen('ps -edf | grep firefox').readlines()
    if len(psFirefox) < 3:
        print '##### open url ... :' + url
        os.system('firefox --display=:1 ' + url + ' &')
        #wid = os.popen('DISPLAY=:1 wmctrl -lp | grep firefox | cut -f1 -d\ ').readlines[0]
        #print wid
        #os.popen('DISPLAY=:1 wmctrl -i -r ' + wid + ' -b toggle,fullscreen,above')
        time.sleep(0)


def shot(name, url):

    try:
        url_open = urllib.urlopen(url)
        infos = url_open.info()
        typ = infos.gettype()

        if url_open.geturl()[:5] != 'https':
            if typ == 'text/html' or typ == 'application/x-shockwave-flash':
                # os.system('DISPLAY=:1 firefox -remote "openurl(' + url + ')"')
                print 'yap'
                launchFirefox(url)
                print 'yop'
                time.sleep(10)
                os.system('DISPLAY=:1 import -window root ' + name + '.png')
                closeFirefox()
            if typ == 'application/pdf':
                urllib.urlretrieve(url,name)
                os.system('gs -dNOPAUSE -sDEVICE=png256 -q -dBATCH -sOutputFile=' + name +'.png ' + name)
            #if typ == 'application/vnd.ms-powerpoint':
            #    urllib.urlretrieve(url,name)
            #    os.system('DISPLAY=:1 pptview ' + name)
            #    time.sleep(20)
            #    os.system('DISPLAY=:1 import -window root ' + name + '.png')
            #    time.sleep(5)
            #    os.system('killall -9 wine')
            #    os.system('killall -9 pptview')
            #    os.system('killall -9 xmessage')

            time.sleep(1)
    except:
        print 'error ...'


def thumb(img):
    os.system('cp ' + img +'.png ' + 'thumb-' + img +'.png ')
    os.system('mogrify -thumbnail 100 thumb-' + img +'.png')

def thumb150(img):
    os.system('cp ' + img +'.png ' + 'thumb150-' + img +'.png ')
    os.system('mogrify -thumbnail 150 thumb150-' + img +'.png')

def vignette(img):
    os.system('convert ' + 'thumb-' + img + '.png -bordercolor grey60 -border 1 -background  black \( +clone -shadow 60x4+4+4 \) +swap -background  none -flatten -depth 8 ' + 'vign-thumb-' + img + '.png')



def getUrlsIdsFromOriIndexing():

    urls_ids = []

    WSDLFILE = 'http://localhost:6380/ori-oai-indexing/xfire/IndexingService?wsdl'
    oriindexing = WSDL.Proxy(WSDLFILE)
    request = 'md-ori-oai-id:("localhost-ori-wf-1-66389")'

    result = oriindexing.searchXMLDocs(request, 1, 1000)['results']['SearchResult']
    if result['id'] != None and result['noticeContent']!= None:
        ide = result['id']
        url = getUrl(result['noticeContent'].encode('utf-8'))
        urls_ids.append((ide, url))
    return urls_ids

    
    
def getUrl(lomXml):
    doc = libxml2.parseDoc(lomXml)
    ctxt = doc.xpathNewContext()
    ctxt.xpathRegisterNs('dc', 'http://purl.org/dc/elements/1.1/')
    res = ctxt.xpathEval("//dc:identifier")
    return res[0].get_content()
    

closeXvfb()
closeFirefox()
initXvfb()
print 'init Xvfb ok ...'
for (id, url) in getUrlsIdsFromOriIndexing():
    url = url.replace('https','http')
    url = url.replace(' ','%20')
    print url + "  ... : " + id
    shot(id, url)
    thumb150(id)
    thumb(id)
    #vignette(id)
closeXvfb()
print 'close Xvfb ok ...'
# suppression fichiers temporaires Flashs de firefox ...
os.system('rm /tmp/Flash*')



