#!/usr/bin/env python
# -*- coding: utf-8 -*-

import sys
import os
import time
from SOAPpy import WSDL
import libxml2
import urllib2
import socket
import cookielib

socket.setdefaulttimeout(100)
cj = cookielib.LWPCookieJar()
opener = urllib2.build_opener(urllib2.HTTPCookieProcessor(cj))
urllib2.install_opener(opener)

# date - 1 jour du dernier png modifie dans le repertoire courant  
#latestFile = sorted(filter(lambda s : s.endswith('.png'), filter(os.path.isfile, os.listdir('.'))), key=lambda p: os.stat(p).st_mtime, reverse=True)[0]
#latestShotTime = os.stat(latestFile).st_mtime-60*60*24
#latestShotTimeFormated = time.strftime("%Y%m%d", time.gmtime(latestShotTime))

def closeFirefox():
    os.system('killall -9 firefox')
    #os.system('killall -3 firefox-bin')
    #os.system('killall -4 firefox-bin')
    #os.system('killall -9 firefox-bin')


def closeXvfb():
    os.system('killall -9 Xvfb')


def initXvfb():
    psXvfb = os.popen('ps -edf | grep Xvfb').readlines()
    if len(psXvfb) < 3:
        os.system('Xvfb :1 -screen 0 1280x960x24&')
        #os.system('Xvfb :1 -screen 0 1024x768x24&')
        #os.system('Xvfb :1 -screen 0 1680x1050x24&')
        time.sleep(3)

def launchFirefox(url):
    psFirefox = os.popen('ps -edf | grep firefox').readlines()
    if len(psFirefox) < 3:
        print '##### open url ... :' + url
        os.system('firefox --display=:1 ' + url + ' &')
        #wid = os.popen('DISPLAY=:1 wmctrl -lp | grep firefox | cut -f1 -d\ ').readlines[0]
        #print wid
        #os.popen('DISPLAY=:1 wmctrl -i -r ' + wid + ' -b toggle,fullscreen,above')
        time.sleep(7)


def shot(name, url):

    try:
        if  True:
            try:
                url_open = urllib2.urlopen(url)
                infos = url_open.info()
                typ = infos.gettype()
                print typ
            except urllib2.URLError, e:
                print e
                typ = 'text/html'


            #if url_open.geturl()[:5] != 'https':
            if typ == 'text/html' or typ == 'application/x-shockwave-flash':
                # os.system('DISPLAY=:1 firefox -remote "openurl(' + url + ')"')
                print '\t $$$$  launchFirefox:' + url + ' ->' + name + '.png'
                launchFirefox(url)
                time.sleep(10)
                os.system('DISPLAY=:1 import -window root ' + name + '.png')
                closeFirefox()
            elif typ == 'application/pdf' or typ[:6] == 'image/':
                print typ
                # urllib.urlretrieve(url,name)
                fic = open(name, 'w')
                fic.write(url_open.read())
                fic.close()
                print "retrieve file ok"
                if typ[:6] == 'image/' :
                    print "renam image"
                    os.system('mv ' + name + " " + name +'.png')
                else:
                    # pdf ?
                    print "gs on pdf"
                    os.system('gs -dNOPAUSE -sDEVICE=png256 -q -dBATCH -sOutputFile=' + name +'.png ' + name)
            #if typ == 'application/vnd.ms-powerpoint':
            #    urllib.urlretrieve(url,name)
            #    os.system('DISPLAY=:1 pptview ' + name)
            #    time.sleep(20)
            #    os.system('DISPLAY=:1 import -window root ' + name + '.png')
            #    time.sleep(5)
            #    os.system('killall -9 wine')
            #    os.system('killall -9 pptview')
            #    os.system('killall -9 xmessage')

            url_open.close()
            time.sleep(1)
    except:
         print "Unexpected error:", sys.exc_info()[0]


def thumb(img):
    os.system('cp ' + img +'.png ' + 'thumb-' + img +'.png ')
    os.system('mogrify -thumbnail 100 thumb-' + img +'.png')

def thumb150(img):
    os.system('cp ' + img +'.png ' + 'thumb150-' + img +'.png ')
    os.system('mogrify -thumbnail 150 thumb150-' + img +'.png')

def vignette(img):
    os.system('convert ' + 'thumb-' + img + '.png -bordercolor grey60 -border 1 -background  black \( +clone -shadow 60x4+4+4 \) +swap -background  none -flatten -depth 8 ' + 'vign-thumb-' + img + '.png')



def getUrlsIdsFromOriIndexing():

    urls_ids = []

    WSDLFILE = 'http://localhost:6380/ori-oai-indexing/xfire/IndexingService?wsdl'
    oriindexing = WSDL.Proxy(WSDLFILE)

    # lom
    #request = 'md-ori-oai-namespace:("http@//ltsc.ieee.org/xsd/LOM")'
    #results = oriindexing.searchXMLDocs(request, 1, 1000)['results']['SearchResult']
    #for result in results:
    #    if result['id'] != None and result['noticeContent']!= None:
    #        ide = result['id']
    #        url = getUrl(result['noticeContent'].encode('utf-8'), 'lom')
    #        urls_ids.append((ide, url))


    # oai_dc
    #request = 'md-ori-oai-namespace:("http://www.openarchives.org/OAI/2.0/oai_dc/") AND (md-ori-oai-datestamp:[' + latestShotTimeFormated + ' TO 21000101])'
    request = 'md-ori-oai-namespace:("http://www.openarchives.org/OAI/2.0/oai_dc/")'
    #request = 'md-ori-oai-namespace:("http://www.openarchives.org/OAI/2.0/oai_dc/") AND %2F%2Fdc%3Atitle:(vincent)'
    print request
    results = oriindexing.searchXMLDocs(request, 1, 10000)['results']['SearchResult']
    for result in results:
        if result['id'] != None and result['noticeContent']!= None:
            ide = result['id']
            doc = libxml2.parseDoc(result['noticeContent'].encode('utf-8'))
            ctxt = doc.xpathNewContext()
            ctxt.xpathRegisterNs('oai_dc_mtgn', 'http://localhost/OAI/oai_dc_mtgn')
            img = ctxt.xpathEval("//oai_dc_mtgn:sticker")
            if img != None and len(img) > 0 and img[0] != None and img[0].get_content() != '':
                img = img[0].get_content()
                f = open(ide + '.png', 'w')
                f.write(img.decode('base64'))
                f.close()
                print "\n" + ide + '.png writed ...' 
                thumb150(ide)
                thumb(ide)
            else:
            #elif not os.path.exists(ide + '.png') or os.path.getsize(ide + '.png')==19580:
                # 19580 == ecran noir
                url_img = 'http://localhost/ori-imgs/thumb150-' + ide +'.png '
                try:
                    url_open = urllib2.urlopen(url_img)
                except urllib2.URLError, e:
                    if(e.code==404):
                        url = getUrl(result['noticeContent'].encode('utf-8'), 'oai_dc')
                        urls_ids.append((ide, url))
                    else:
                        print e
            
            #url = getUrl(result['noticeContent'].encode('utf-8'), 'oai_dc')            
            #if url.startswith("http://www.bioone.org"):
            #    urls_ids.append((ide, url))
    print "total des fiches a traiter :" + str(len(urls_ids))
    return urls_ids

    
    
def getUrl(lomXml, format):
    doc = libxml2.parseDoc(lomXml)
    ctxt = doc.xpathNewContext()
    res = []

    if format == 'lom':
        ctxt.xpathRegisterNs('lom', 'http://ltsc.ieee.org/xsd/LOM')
        res = ctxt.xpathEval("//lom:technical/lom:location")

    else:
        ctxt.xpathRegisterNs('dc', 'http://purl.org/dc/elements/1.1/')
        res = ctxt.xpathEval("//dc:identifier")
        if not True in [ident.get_content()[:4] == 'http' for ident in res]:
            res = ctxt.xpathEval("//dc:relation")
        if not True in [ident.get_content()[:4] == 'http' for ident in res]:
            res = ctxt.xpathEval("//dc:source")


    res_url = ''
    for r in res:
        if r.get_content()[:4] == 'http':
            res_url = r.get_content()
        
    #return res[0].get_content()
    return res_url
    

#closeXvfb()
closeFirefox()
initXvfb()
print 'init Xvfb ok ...'
for (id, url) in getUrlsIdsFromOriIndexing():
    url = url.replace('https','http')
    url = url.replace(' ','%20')
    url = url.replace('(','%28')
    url = url.replace(')','%29')
    print url + "  ... : " + id
    if  url != '':
        shot(id, url)
        thumb150(id)
        thumb(id)
        #vignette(id)
closeXvfb()
print 'close Xvfb ok ...'
# suppression fichiers temporaires Flashs de firefox ...
os.system('rm /tmp/Flash*')



